import azure.cosmos.documents as documents
import azure.cosmos.cosmos_client as cosmos_client
import azure.cosmos.exceptions as exceptions
from azure.cosmos.partition_key import PartitionKey
from ..configs.config import Settings


HOST = Settings['host']
MASTER_KEY = Settings['master_key']
DATABASE_ID = Settings['database_id']
CONTAINER_ID = Settings['container_id']
CONTAINER_ID2 = Settings['container_id2']
CONTAINER_ID3 = Settings['container_id3']
CONTAINER_ID4 = Settings['container_id4']
CONTAINER_ID5 = Settings['container_id5']
CONTAINER_ID6 = Settings['container_id6']
CONTAINER_ID7 = Settings['container_id7']
CONTAINER_ID8 = Settings['container_id8']
CONTAINER_ID9 = Settings['container_id9']
CONTAINER_ID10 = Settings['container_id10']
CONTAINER_ID11 = Settings['container_id11']
CONTAINER_ID12 = Settings['container_id12']
CONTAINER_ID13 = Settings['container_id13']
CONTAINER_ID14 = Settings['container_id14']
CONTAINER_ID15 = Settings['container_id15']


class Singleton:
    def __init__(self, cls):
        self._cls = cls

    def Instance(self):
        try:
            return self._instance
        except AttributeError:
            self._instance = self._cls()
            return self._instance

    def __call__(self):
        raise TypeError('Singletons must be accessed through `Instance()`.')

    def __instancecheck__(self, inst):
        return isinstance(inst, self._cls)

@Singleton
class DBConnection(object):
    url_ = HOST
    key_ = MASTER_KEY
    database_id_ = DATABASE_ID
    container_id_ = CONTAINER_ID
    container_id_2 = CONTAINER_ID2
    container_id_3 = CONTAINER_ID3
    container_id_4 = CONTAINER_ID4
    container_id_5 = CONTAINER_ID5
    container_id_6 = CONTAINER_ID6
    container_id_7 = CONTAINER_ID7
    container_id_8 = CONTAINER_ID8
    container_id_9 = CONTAINER_ID9
    container_id_10 = CONTAINER_ID10
    container_id_11 = CONTAINER_ID11
    container_id_12 = CONTAINER_ID12
    container_id_13 = CONTAINER_ID13
    container_id_14 = CONTAINER_ID14
    container_id_15 = CONTAINER_ID15
    def __init__(self):
        self.client = cosmos_client.CosmosClient(self.url_, {'masterKey': self.key_})
        self.db = self.client.get_database_client(self.database_id_)
        self.container = self.db.get_container_client(self.container_id_)
        self.container2 = self.db.get_container_client(self.container_id_2)
        self.container3 = self.db.get_container_client(self.container_id_3)
        self.container4 = self.db.get_container_client(self.container_id_4)
        self.container5 = self.db.get_container_client(self.container_id_5)
        self.container6 = self.db.get_container_client(self.container_id_6)
        self.container7 = self.db.get_container_client(self.container_id_7)
        self.container8 = self.db.get_container_client(self.container_id_8)
        self.container9 = self.db.get_container_client(self.container_id_9)
        self.container10 = self.db.get_container_client(self.container_id_10)
        self.container11 = self.db.get_container_client(self.container_id_11)
        self.container12 = self.db.get_container_client(self.container_id_12)
        self.container13 = self.db.get_container_client(self.container_id_13)
        self.container14 = self.db.get_container_client(self.container_id_14)
        self.container15 = self.db.get_container_client(self.container_id_15)

callConnect = DBConnection.Instance()